/*************************************************************************
Title:    testing output to a HD44780 based LCD display.
Author:   Peter Fleury  <pfleury@gmx.ch>  http://jump.to/fleury
File:     $Id: test_lcd.c,v 1.6 2004/12/10 13:53:59 peter Exp $
Software: AVR-GCC 3.3
Hardware: HD44780 compatible LCD text display
          ATS90S8515/ATmega if memory-mapped LCD interface is used
          any AVR with 7 free I/O pins if 4-bit IO port mode is used
**************************************************************************/
#include <stdlib.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "lcd.h"
#include <util/delay.h>
   
unsigned int uart_putc(unsigned char c)
{
  while (!(UCSRA & (1<<UDRE)))  /* warten bis Senden moeglich */
  {
  }
 
  UDR = c;                      /* sende Zeichen */
  return 0;
}

//---------------------------------------------------------------------------
int sendx(void)
{
  while (!(UCSRA & (1<<UDRE)))  /* warten bis Senden moeglich */
  {
  }
 
  UDR = 'x';                      /* sende Zeichen */
}
int senda(void)
{
  while (!(UCSRA & (1<<UDRE)))  /* warten bis Senden moeglich */
  {
  }
 
  UDR = 'a';                      /* sende Zeichen */
}

//---------------------------------------------------------------------------

void uart_puts (unsigned char *s)
{
  while (*s)
  {   /* so lange *s != '\0' also ungleich dem "String-Endezeichen" */
    uart_putc(*s);
    s++;
  }
}
//-------------------------------------------------------------------------------
void Disp_Messung(short i)
{
	switch (i)
	{
		case 1:   lcd_puts("Messung - 1 ?\nOK = OK-Taste");
		break;		
		case 2:	  lcd_puts("Messung - 2 ?\nOK = OK-Taste");
		break;
		case 3:	  lcd_puts("Messung - 3 ?\nOK = OK-Taste");
		break;
		case 4:	  lcd_puts("Messung - 4 ?\nOK = OK-Taste");
		break;
		case 5:   lcd_puts("Messung - 5 ?\nOK = OK-Taste");
		break;
	}
}

//------------------------------------------------------------------------------


unsigned int wandle(unsigned int y)
{
unsigned char Buffer[20];
  unsigned int i = y;

  sprintf( Buffer, "%u", i );

  uart_puts( Buffer );

}
//------------------------------------------------------------------------------
/*
** constant definitions
*/
static const PROGMEM unsigned char copyRightChar[] =
{
	0x07, 0x08, 0x13, 0x14, 0x14, 0x13, 0x08, 0x07,
	0x00, 0x10, 0x08, 0x08, 0x08, 0x08, 0x10, 0x00
};

//------------------------------------------------------------------------------

/*
** function prototypes
*/ 
void wait_until_key_pressed(void);


void wait_until_key_pressed(void)
{
    unsigned char temp1, temp2;
    unsigned int i;
    
    do {
        temp1 = PIND;                  // read input
        for(i=0;i<65535;i++);
        temp2 = PIND;                  // read input
        temp1 = (temp1 & temp2);       // debounce input
    } while ( temp1 & _BV(PIND2) );
    
    loop_until_bit_is_set(PIND,PIND2);            /* wait until key is released */
}


//-------------------------------------------------------------------------------------------

void Messung_laeuft(int y)
{
	
	switch (y)
	{
	case 0:
	lcd_puts("Messung-1 lauft");
	break;
	case 1:
	lcd_puts("Messung-2 lauft");
	break;
	case 2:
	lcd_puts("Messung-3 lauft");
	break;
	case 3:
	lcd_puts("Messung-4 lauft");
	break;
	case 4:
	lcd_puts("Messung-5 lauft");
	break;
}
}

void Messung_fertig(int x)
{
	switch (x)
	{
		case 0:
		lcd_puts("Messung-1 fertig");
		break;
		case 1:
		lcd_puts("Messung-2 fertig");
		break;
		case 2:
       lcd_puts("Messung-3 fertig");
	   break;
    }
}

//--------------------------------------------------------------
int main(void)
{
    char buffer[7];
    int  num=134;
    
    
    
    DDRD &=~ (1 << PD2);        /* Pin PD2 input              */
    PORTD |= (1 << PD2);        /* Pin PD2 pull-up enabled    */


    /* initialize display, cursor off */
    lcd_init(LCD_DISP_ON);

    unsigned int overflow = 0;
  	unsigned int ubergabe[40] = {0};
	unsigned int reg[40] = {0};
	unsigned int Sicherheitsloop = 0;
	unsigned short iZaehl = 0;
	unsigned char i = 0;
	unsigned short AnzahlDurchlaufe = 0;
	unsigned int iMessung=0;
	char MessungFertig=0;
	char taste_gedrueckt=0;
	char tastenzaehler=0;
	char Durchgang=1;
	char ok_gedrueckt=0;
	DDRD =0xFF; 											//UART
	DDRB =0x00; 											//Lichtschranken
	DDRA =0xFF;											//Port fr LCD
	DDRC =0x00; 											//Port fr div. Steuer-Taster


	PORTA = 0x00;


	//TCCR0 |=  (1<<CS00)|(1<<CS02);								//Prescaler fr Timer auf 1024					

	UCSRB |= (1<<TXEN);              								//Senden aktivieren
	UCSRC |= (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1);  

	UBRRH = 00;                      								//Baudrate einstellen 9600 bei 8 MHz
	UBRRL = 51;

	       
         
        											
        lcd_clrscr();    										//Display lschen
        lcd_puts("Mit SCROLL-Taste\nDurchlauf wahlen");
		//lcd_puts("Mit SCROLLtaster\nDurchlauf wahlen");		//Ausgangstext auf dem Display
       	                                                        //Steuerbefehl an das Display senden
   	for(;;)
  	{
    	
    if (TIFR &(1<<TOV0)) 									//wenn generell berlauf, erhhe Variable "uberlauf" um eins
  		{
  			overflow++;
  			TIFR = 1<<TOV0;
  		}
    													
    													
    	
			
			if(PINC == 0xFE)							//wenn Scroll-Taste gedrckt wird...
    		{
		
    			taste_gedrueckt = 0;
    
    													//
    													// Solange die Taste an Pin0 von PORTC nicht losgelassen 
    													// wurde: warten
    													//
    			while(PINC == 0xFE)
    			{
      													// Entprellen: Taste ist mindestens 25ms lang gedrckt
      			
      			if (PINC == 0xFE)
        		taste_gedrueckt = 1;
    			}
				
    			if (taste_gedrueckt)
    			{
      				taste_gedrueckt = 0;
      				tastenzaehler++;
				if (tastenzaehler==6)
					tastenzaehler=1;
				lcd_clrscr();
				Disp_Messung(tastenzaehler);
    			}
			

    		}
		
		if (PINC == 0xFB)								//Wenn OK-Taste gedrckt...
		{
			
			
			lcd_clrscr();
			Messung_laeuft(tastenzaehler-1);
		}
		
 	  	switch(PINB)
	  	{
        
            case 0xFE:
			TCCR0 |=  (1<<CS00)|(1<<CS02);	               //Timer starten                  
    		reg[0]=TCNT0;
    		ubergabe[0]=overflow;
			break;



			case 0xFD:
				reg[1*tastenzaehler]=TCNT0;
                ubergabe[1*tastenzaehler]=overflow;
			break;



			case 0xFB:
				reg[2*tastenzaehler]=TCNT0;
				ubergabe[2*tastenzaehler]=overflow;
			break;



			case 0xF7:
				reg[3*tastenzaehler]=TCNT0;
				ubergabe[3*tastenzaehler]=overflow;
			break;



			case 0xEF:
				reg[4*tastenzaehler]=TCNT0;
				ubergabe[4*tastenzaehler]=overflow;
			break;



			case 0xDF:
				reg[5*tastenzaehler]=TCNT0;
				ubergabe[5*tastenzaehler]=overflow;
			break;
			
			
				
			case 0xBF:
				reg[6*tastenzaehler]=TCNT0;
				ubergabe[6*tastenzaehler]=overflow;
			break;



			case 0x7F:
				reg[7*tastenzaehler]=TCNT0;
				ubergabe[7*tastenzaehler]=overflow;
				lcd_clrscr();
				Messung_fertig(tastenzaehler-1);										//Durchgang der Messung fr Display erhhen
			
			
			
			break;
			
			
		}
																		//Ab hier Sendevorgang ber RS232

	if (PINC==0xFE)													//wenn Send-Taster gedrckt...
	{
		senda();													//schicke "a"...
		
		for(Sicherheitsloop=0;Sicherheitsloop<50;Sicherheitsloop++) //Schickt das Ganze 50x an das VB-Programm (aus Sicherheitsgrnden)
		{
			for(iZaehl=0; iZaehl <= 7; iZaehl++)                    //schickt die einzelnen Reg./berlauf-Eintrge an das VB-Programm
			{
				wandle(reg[iZaehl+AnzahlDurchlaufe]);
				sendx();
				wandle(ubergabe[iZaehl+AnzahlDurchlaufe]);
			}
		  
				
				TCCR0=0;													//Timer-Reg. auf NULL
	}	
}
}
	
}

